<?php

namespace RxConnexionBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;
use RxConnexionBundle\Entity\AccountEntity;
use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Form\AccountForm;

/**
 * @Route("/main/account")
 */
class AccountController extends Controller
{
    /**
     * @Route("", name="account")
     */
    public function indexAction(Request $request)
    {
        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Account'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/Account/index.html.twig', array(
            'title' => 'Manage Account',
            'page_title' => 'Manage Account',
            'javascripts' => array('rxconnexion/admin/js/account/account.js?v=1.0.0'),
        ));
    }

    /**
     * @Route("/ajax_list", name="account_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Account Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:AccountEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('account_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['id'],
                    $row['code'],
                    $row['description'],
                    $row['e_mail'],
                    $row['mobile_no'],
                    $row['phone_no'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "account_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Account New', 'Admin Account Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $account = $em->getRepository('RxConnexionBundle:AccountEntity')->find(base64_decode($id));
        if(!$account) {
            $account = new AccountEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(AccountForm::class, $account, $formOptions);

        if($request->getMethod() === 'POST') {

            $account_form = $request->get($form->getName());
            $result = $this->processForm($account_form, $account, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('account'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('account_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('account_form'), 302);
                }
            } else {
                $form->submit($account_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Account';

        return $this->render('@RxConnexion/Account/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($account_form, $account, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:AccountEntity')->validate($account_form);

        if(!count($errors)) {

            switch($account_form['action']) {

                case 'n': // new

                    //$form->handleRequest($request);
                    $form->submit($account_form, false);

                    if($form->isValid()) {

                        $em->persist($account);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'Account',
                            $em->getClassMetadata(AccountEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $account;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    $result['redirect'] = 'index';

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Account',
                        $em->getClassMetadata(AccountEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $account;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');
                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $form->submit($account_form, false);

                    $newAT = new AuditTrailEntity(
                        'Account',
                        $em->getClassMetadata(AccountEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $account;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    if($form->isValid()) {

                        //$agency = $em->getRepository('RxConnexionBundle:AgencyEntity')->find($account_form['id']);
                        //$em->remove($account);
                        $account->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="account_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:AccountEntity')->autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }
}
